



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>4.Knockout.Js（事件绑定）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">4.Knockout.Js（事件绑定）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 13:32:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前言</p>
<p>click绑定在DOM元素上添加事件句柄以便元素被点击的时候执行定义的JavaScript 函数。大部分是用在button，input和连接a上，但是可以在任意元素上使用。</p>
<p>简单示例</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;h2&gt;ClickBind&lt;/h2&gt;<br />
&lt;div&gt;<br />
    You've clicked &lt;span data-bind="text: numberOfClicks"&gt;&lt;/span&gt; times<br />
    &lt;button data-bind="click: incrementClickCounter"&gt;Click me&lt;/button&gt;<br />
&lt;/div&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        numberOfClicks: ko.observable(0),<br />
        incrementClickCounter: function() {<br />
            var previousCount = this.numberOfClicks();<br />
            this.numberOfClicks(previousCount + 1);<br />
        }<br />
    };<br />
    ko.applyBindings(viewModel);<br />
&lt;/script&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>预览效果</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/14183018-7f8bd7f328704d25ae26c6163b54cf3c.png" />　　</p>
<p>每次点击按钮的时候，都会调用incrementClickCounter()函数，然后更新自动更新点击次数。</p>
<p>你可以声明任何JavaScript函数 &ndash; 不一定非要是view model里的函数。你可以声明任意对象上的任何函数，例如： someObject.someFunction。</p>
<p>View model上的函数在用的时候有一点点特殊，就是不需要引用对象的，直接引用函数本身就行了，比如直接写incrementClickCounter 就可以了，而无需写成： viewModel.incrementClickCounter（尽管是合法的）。</p>
<p><strong>传参数给你的click 句柄</strong></p>
<p>最简单的办法是传一个function包装的匿名函数：</p>
<div>
<pre class="prettyprint linenums">&lt;button data-bind="click: function() { viewModel.myFunction('param1', 'param2') }"&gt;<br />
    Click me<br />
&lt;/button&gt;</pre>
</div>
<p>这样，KO就会调用这个匿名函数，里面会执行viewModel.myFunction()，并且传进了'param1' 和'param2'参数。</p>
<p>访问事件源对象</p>
<p>有些情况，你可能需要使用事件源对象，Knockout会将这个对象传递到你函数的第一个参数：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;button data-bind="click: myFunction"&gt;<br />
    Click me   event<br />
&lt;/button&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        numberOfClicks: ko.observable(0),<br />
        incrementClickCounter: function() {<br />
            var previousCount = this.numberOfClicks();<br />
            this.numberOfClicks(previousCount + 1);<br />
        },<br />
        myFunction: function (event) {<br />
            //////<br />
        }<br />
    };<br />
    ko.applyBindings(viewModel);<br />
&lt;/script&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>如果你需要的话，可以使用匿名函数的第一个参数传进去，然后在里面调用：</p>
<div>
<pre class="prettyprint linenums">&lt;button data-bind="click: function(event) { viewModel.myFunction(event, 'param1', 'param2') }"&gt;<br />
    Click me<br />
&lt;/button&gt;</pre>
</div>
<p>这样，KO就会将事件源对象传递给你的函数并且使用了。</p>
<p><strong>允许执行默认事件</strong></p>
<p>默认情况下，Knockout会阻止冒泡，防止默认的事件继续执行。例如，如果你点击一个a连接，在执行完自定义事件时它不会连接到href地址。这特别有用是因为你的自定义事件主要就是操作你的view model，而不是连接到另外一个页面。</p>
<p>当然，如果你想让默认的事件继续执行，你可以在你click的自定义函数里返回true。</p>
<p>防止事件冒泡</p>
<p>默认情况下，Knockout允许click事件继续在更高一层的事件句柄上冒泡执行。例如，如果你的元素和父元素都绑定了click事件，那当你点击该元素的时候两个事件都会触发的。如果需要，你可以通过额外的绑定clickBubble来禁止冒泡。例如：</p>
<div>
<pre class="prettyprint linenums">&lt;div data-bind="click: myDivHandler"&gt;<br />
    &lt;button data-bind="click: myButtonHandler, clickBubble: false"&gt;<br />
        Click me<br />
    &lt;/button&gt;<br />
&lt;/div&gt;</pre>
</div>
<p>默认情况下，myButtonHandler会先执行，然后会冒泡执行myDivHandler。但一旦你设置了clickBubble为false的时候，冒泡事件会被禁止</p>
<p><a href="http://www.cnblogs.com/aehyok/p/3369785.html" rel="external nofollow noreferrer">Knockout.Js官网学习（event绑定、submit绑定）</a></p>
<p>event绑定</p>
<p>event绑定在DOM元素上添加指定的事件句柄以便元素被触发的时候执行定义的JavaScript 函数。大部分情况下是用在keypress，mouseover和mouseout上。</p>
<p>简单示例</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;div&gt;<br />
    &lt;div data-bind="event: { mouseover: enableDetails, mouseout: disableDetails }"&gt;        Mouse over me    &lt;/div&gt;<br />
    &lt;div data-bind="visible: detailsEnabled"&gt;        Details    &lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        detailsEnabled: ko.observable(false),<br />
        enableDetails:function() {<br />
            this.detailsEnabled(true);<br />
        },<br />
        disableDetails:function () {<br />
            this.detailsEnabled(false);<br />
        }<br />
    };<br />
    ko.applyBindings(viewModel);<br />
&lt;/script&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>就是通过在一个div上绑定两个事件，一个鼠标点上去的mouseover让下面的div内容显示出来，另一个是鼠标移出mouseout让下面的div内容再隐藏。</p>
<p>你可以声明任何JavaScript函数 &ndash; 不一定非要是view model里的函数。你可以声明任意对象上的任何函数，例如： event: { mouseover: someObject.someFunction }。</p>
<p>View model上的函数在用的时候有一点点特殊，就是不需要引用对象的，直接引用函数本身就行了，比如直接写event: { mouseover: enableDetails } 就可以了，而无需写成： event: { mouseover: viewModel.enableDetails }（尽管是合法的）。</p>
<p>submit绑定</p>
<p>submit绑定在form表单上添加指定的事件句柄以便该form被提交的时候执行定义的JavaScript 函数。只能用在表单form元素上。</p>
<p>当你使用submit绑定的时候， Knockout会阻止form表单默认的submit动作。换句话说，浏览器会执行你定义的绑定函数而不会提交这个form表单到服务器上。可以很好地 解释这个，使用 &nbsp;submit绑定就是为了处理view model的自定义函数的，而不是再使用普通的HTML form表单。如果你要继续执行默认的HTML form表单操作，你可以在你的submit句柄里返回true。</p>
<p>submit简单示例</p>
<div>
<pre class="prettyprint linenums">&lt;form data-bind="submit: doSomething"&gt;    ... form contents go here ...<br />
&lt;input type="text" value="1" id="test"/&gt;<br />
&lt;button type="submit"&gt;Submit&lt;/button&gt;<br />
&lt;/form&gt;</pre>
</div>
<p>简单的UI元素</p>
<div>
<pre class="prettyprint linenums">        doSomething: function (formElement) {<br />
            alert(formElement[0].outerHTML);<br />
        }</pre>
</div>
<p>简单的viewModel属性</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/15105127-8107346b3f1e4b3bb3f5d963965f8a92.png" /></p>
<p>总共有两个元素一个是录入框，另一个是submit提交按钮</p>
<p>在form上，你可以使用click绑定代替submit绑定。不过submit可以handle其它的submit行为，比如在输入框里输入回车的时候可以提交表单。</p>
<p><a href="http://www.cnblogs.com/aehyok/p/3370135.html" rel="external nofollow noreferrer">Knockout.Js官网学习（enable绑定、disable绑定）</a></p>
<div>
<p>enable绑定</p>
<p>enable绑定使DOM元素只有在参数值为 true的时候才enabled。在form表单元素input，select，和textarea上非常有用。</p>
<p>enable简单示例</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;h2&gt;enableBind&lt;/h2&gt;<br />
&lt;p&gt;    &lt;input type='checkbox' data-bind="checked: hasCellphone"/&gt;    I have a cellphone&lt;/p&gt;<br />
&lt;p&gt;    Your cellphone number:    &lt;input type='text' data-bind="value: cellphoneNumber, enable: hasCellphone"/&gt;&lt;/p&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        hasCellphone: ko.observable(false),<br />
        cellphoneNumber:ko.observable("")<br />
    };<br />
    ko.applyBindings(viewModel);<br />
&lt;/script&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>这个例子里，&ldquo;Your cellphone number&rdquo;后的text box 初始情况下是禁用的，只有当用户点击标签 &ldquo;I have a cellphone&rdquo;的时候才可用。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/15123922-72c1e3055410428fab020be556e49b77.png" /></p>
<p>声明DOM元素是否可用enabled。</p>
<p>非布尔值会被解析成布尔值。例如0和null被解析成false，21和非null对象被解析给true。</p>
<p>如果你的参数是observable的，那绑定会随着observable值的改变而自动更新enabled/disabled状态。如果不是，则只会设置一次并且以后不再更新。</p>
<p>任意使用JavaScript表达式</p>
<p>不紧紧限制于变量 &ndash; 你可以使用任何JavaScript表达式来控制元素是否可用。例如</p>
<div>
<pre class="prettyprint linenums">&lt;button data-bind="enable: parseAreaCode(viewModel.cellphoneNumber()) != '555'"&gt;   <br /> 　　Do something<br />&lt;/button&gt;</pre>
</div>
<p>disable绑定</p>
<p>disable绑定使DOM元素只有在参数值为 true的时候才disabled。在form表单元素input，select，和textarea上非常有用。</p>
<p>disable绑定和enable绑定正好相反，详情请参考enable绑定</p>
<p><a href="http://www.cnblogs.com/aehyok/p/3372298.html" rel="external nofollow noreferrer">Knockout.Js官网学习（value绑定）</a></p>
<p>前言</p>
<p>value绑定是关联DOM元素的值到view model的属性上。主要是用在表单控件&lt;input&gt;，&lt;select&gt;和&lt;textarea&gt;上。</p>
<p>当用户编辑表单控件的时候， view model对应的属性值会自动更新。同样，当你更新view model属性的时候，相对应的元素值在页面上也会自动更新。</p>
<p>注：如果你在checkbox或者radio button上使用checked绑定来读取或者写入元素的 checked状态，而不是value 值的绑定。</p>
<p>简单示例</p>
<p>代码如下对两个input进行value的属性绑定</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;p&gt;Login name: &lt;input data-bind="value: userName"/&gt;&lt;/p&gt;<br />
&lt;p&gt;Password: &lt;input type="password" data-bind="value: userPassword"/&gt;&lt;/p&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        userName: ko.observable(""),<br />
        userPassword: ko.observable("abc")<br />
    };<br />
    ko.applyBindings(viewModel);<br />
&lt;/script&gt; </pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>运行后效果为</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/16135458-27342bec1b994bd29f0e0a18b5ce7f63.png" /></p>
<p>注意密码的type为password</p>
<p>KO设置此参数为元素的value值。之前的值将被覆盖。</p>
<p>如果参数是监控属性observable的，那元素的value值将根据参数值的变化而更新，如果不是，那元素的value值将只设置一次并且以后不在更新。</p>
<p>如果你提供的参数不是一个数字或者字符串（而是对象或者数组）的话，那显示的value值就是yourParameter.toString() 的内容（通常没用，所以最好都设置为数字或者字符串）。</p>
<p>不管什么时候，只要你更新了元素的值，那 KO都会将view model对应的属性值自动更新。默认情况下当用户离开焦点（例如onchange事件）的时候，KO才更新这个值，但是你可以通过第2个参数valueUpdate来特别指定改变值的时机。</p>
<p>valueUpdate</p>
<p>如果你使用valueUpdate参数，那就是意味着KO将使用自定义的事件而不是默认的离开焦点事件。下面是一些最常用的选项：</p>
<p>&ldquo;change&rdquo;（默认值） - 当失去焦点的时候更新view model的值，或者是&lt;select&gt; 元素被选择的时候。</p>
<p>&ldquo;keyup&rdquo; &ndash; 当用户敲完一个字符以后立即更新view model。</p>
<p>&ldquo;keypress&rdquo; &ndash; 当用户正在敲一个字符但没有释放键盘的时候就立即更新view model。不像 keyup，这个更新和keydown是一样的。</p>
<p>&ldquo;afterkeydown&rdquo; &ndash; 当用户开始输入字符的时候就更新view model。主要是捕获浏览器的keydown事件或异步handle事件。</p>
<p>上述这些选项，如果你想让你的view model进行实时更新，使用&ldquo;afterkeydown&rdquo;是最好的选择。</p>
<div>
<pre class="prettyprint linenums">&lt;p&gt;Your value: &lt;input data-bind="value: someValue, valueUpdate: 'afterkeydown'"/&gt;&lt;/p&gt;<br />
&lt;p&gt;You have typed: &lt;span data-bind="text: someValue"&gt;&lt;/span&gt;&lt;/p&gt;</pre>
<div>
<pre class="prettyprint linenums">someValue: ko.observable("edit me")</pre>
</div>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/16135925-c7663935c5bc4d7d8aef8d8e7c19c9ac.png" /></p>
<p>绑定下拉菜单drop-down list（例如SELECT）</p>
<p>Knockout对下拉菜单drop-down list绑定有一个特殊的支持，那就是在读取和写入绑定的时候，这个值可以是任意JavaScript对象，而不必非得是字符串。在你让你用户选择一组model对象的时候非常有用。具体例子，参考options绑定。</p>
<p>类似，如果你想创建一个multi-select list，参考selectedOptions绑定。</p>
<p>更新observable和non-observable属性值</p>
<p>如果你用value绑定将你的表单元素和你的observable属性关联起来，KO设置的2-way的双向绑定，任何一方改变都会更新另外一方的值。</p>
<p>但是，如果你的元素绑定的是一个non-observable属性（例如是一个原始的字符串或者JavaScript表达式） ,KO会这样执行：</p>
<p>　　1.如果你绑定的non-observable属性是简单对象，例如一个常见的属性值，KO会设置这个值为form表单元素的初始值，如果你改 变form表单元素的值，KO会将值重新写回到view mode的这个属性。但当这个属性自己改变的时候，元素却不会再变化了（因为不是observable的），所以它仅仅是1-way绑定。</p>
<p>　　2.如果你绑定的non-observable属性是复杂对象，例如复杂的JavaScript 表达式或者子属性，KO也会设置这个值为form表单元素的初始值，但是改变form表单元素的值的时候，KO不会再写会view model属性，这种情况叫one-time-only value setter，不是真正的绑定。</p>
<p>例如：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;p&gt;First value: &lt;input data-bind="value: firstValue"/&gt;&lt;/p&gt;          &lt;!-- two-way binding --&gt;<br />
&lt;p&gt;Second value: &lt;input data-bind="value: secondValue"/&gt;&lt;/p&gt;        &lt;!-- one-way binding --&gt;<br />
&lt;p&gt;Third value: &lt;input data-bind="value: secondValue.length"/&gt;&lt;/p&gt;  &lt;!-- no binding --&gt; 

&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        firstValue: ko.observable("hello"), // Observable<br />
        secondValue: "hello, again"// Not observable<br />
    };<br />
    ko.applyBindings(viewModel);<br />
&lt;/script&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><a href="http://www.cnblogs.com/aehyok/p/3374576.html" rel="external nofollow noreferrer">Knockout.Js官网学习（checked 绑定）</a></p>
<p>前言</p>
<p>checked绑定是关联到checkable的form表单控件到view model上 - 例如checkbox（&lt;input type='checkbox'&gt;）或者radio button（&lt;input type='radio'&gt;） 。当用户check关联的form表单控件的时候，view model对应的值也会自动更新，相反，如果view model的值改变了，那控件元素的check/uncheck状态也会跟着改变。</p>
<p>注：对text box，drop-down list和所有non-checkable的form表单控件，用value绑定来读取和写入是该元素的值，而不是checked绑定。</p>
<p>简单示例</p>
<p>示例代码</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;p&gt;Send me spam:&lt;input type="checkbox" data-bind="checked:wantsSpam" /&gt;&lt;/p&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        wantsSpam:ko.observable(true)<br />
    };

    viewModel.wantsSpam(false);<br />
    ko.applyBindings(viewModel);<br />
&lt;/script&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>运行之后</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/17162135-8fd0bc7faee24e80a6cb75cb3dd86c3a.png" /></p>
<p>对于checkbox，当参数为true的时候，KO会设置元素的状态为checked，反正设置为unchecked。如果你传的参数不是布尔值，那KO将会解析成布尔值。也就是说非0值和非null对象，非空字符串将被解析成true，其它值都被解析成false。</p>
<p>当用户check或者uncheck这个checkbox的时候，KO会将view model的属性值相应地设置为true或者false。</p>
<p>Checkbox关联到数组</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;p&gt;Send me spam:&lt;input type="checkbox" data-bind="checked:wantsSpam" /&gt;&lt;/p&gt;<br />
&lt;div data-bind="visible: wantsSpam"&gt;<br />
    Preferred flavors of spam:<br />
    &lt;div&gt;<br />
        &lt;input type="checkbox" value="cherry" data-bind="checked: spamFlavors"/&gt; Cherry<br />
    &lt;/div&gt;<br />
    &lt;div&gt;<br />
        &lt;input type="checkbox" value="almond" data-bind="checked: spamFlavors"/&gt; Almond<br />
    &lt;/div&gt;<br />
    &lt;div&gt;<br />
        &lt;input type="checkbox" value="msg" data-bind="checked: spamFlavors"/&gt; Monosodium Glutamate<br />
    &lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        wantsSpam: ko.observable(true),<br />
        spamFlavors: ko.observableArray(["cherry", "almond"])<br />
    };<br />
    ko.applyBindings(viewModel);<br />
    viewModel.wantsSpam(false);<br />
    viewModel.spamFlavors.push("msg");<br />
&lt;/script</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/17163231-93c622347801479099babe7f0cf6768a.png" /></p>
<p>添加radio button</p>
<div>
<pre class="prettyprint linenums">    &lt;div&gt;&lt;input type="radio" name="flavorGroup" value="cherry" data-bind="checked: spamFlavor"/&gt; Cherry&lt;/div&gt;<br />
    &lt;div&gt;&lt;input type="radio" name="flavorGroup" value="almond" data-bind="checked: spamFlavor"/&gt; Almond&lt;/div&gt;<br />
    &lt;div&gt;&lt;input type="radio" name="flavorGroup" value="msg" data-bind="checked: spamFlavor"/&gt; Monosodium Glutamate&lt;/div&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">spamFlavor:ko.observable("cherry")</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/17171919-90cb3047be974f4c9f790cd72e11a89e.png" /></p>
<p>对于radio buttons，KO只有当参数值等于radio button value属性值的时候才设置元素为checked状态。所以参数应是字符串。在上面的例子里只有当view model 的spamFlavor 属性等于&ldquo;almond&rdquo;的时候，该radio button才会设置为checked。</p>
<p>当然，最有用的是设置一组radio button元素对应到一个单个的view model 属性。确保一次只能选择一个radio button需要将他们的name属性名都设置成一样的值（例如上个例子的flavorGroup值）。这样的话，一次就只能选择一个了。</p>
<p>如果参数是监控属性observable的，那元素的checked状态将根据参数值的变化而更新，如果不是，那元素的value值将只设置一次并且以后不在更新</p>
<p><a href="http://www.cnblogs.com/aehyok/p/3374713.html" rel="external nofollow noreferrer">Knockout.Js官网学习（options绑定）</a></p>
<div>
<p>前言</p>
<p>options绑定控制什么样的options在drop-down列表里（例如：&lt;select&gt;）或者 multi-select 列表里 （例如：&lt;select size='6'&gt;）显示。此绑定不能用于&lt;select&gt;之外的元素。关联的数据应是数组（或者是observable数组），&amp; lt;select&gt;会遍历显示数组里的所有的项。</p>
<p>对于multi-select列表，设置或者获取选择的多项需要使用selectedOptions绑定。对于single-select列表，你也可以使用value绑定读取或者设置元素的selected项。</p>
<p>Drop-down list</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;p&gt;Destination country: &lt;select data-bind="options: availableCountries"&gt;&lt;/select&gt;&lt;/p&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        availableCountries: ko.observableArray(['France', 'Germany', 'Spain'])<br />
    };<br />
    ko.applyBindings(viewModel);<br />
    viewModel.availableCountries.push('China');<br />
&lt;/script&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/17184352-96a50f00a5f140b9af40b528757cfc03.png" /></p>
<p>该参数是一个数组（或者observable数组）。对每个item，KO都会将它作为一个&lt;option&gt; 添加到&lt;select&gt;里，之前的options都将被删除。</p>
<p>如果参数是一个string数组，那你不需要再声明任何其它参数。&lt;select&gt;元素会将每个string显示为一个option。 不过，如果你让用户选择的是一个JavaScript对象数组（不仅仅是string），那就需要设置optionsText和optionsValue 这两个参数了。</p>
<p>如果参数是监控属性observable的，那元素的options项将根据参数值的变化而更新，如果不是，那元素的value值将只设置一次并且以后不在更新。</p>
<p>如果对上面的select UI元素加上multiple="true"</p>
<div>
<pre class="prettyprint linenums">&lt;select data-bind="options: availableCountries" multiple="true"&gt;&lt;/select&gt;</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/17184644-e90033b8720d4ee7bbd51dd5b2b0432c.png" /></p>
<p>这可以说是<strong>Multi-select list</strong></p>
<p>Drop-down list展示的任意JavaScript对象，不仅仅是字符串</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;p&gt;Destination country: &lt;select data-bind="options: availableCountries" multiple="true"&gt;&lt;/select&gt;&lt;/p&gt;<br />
&lt;p&gt;    Your country:<br />
    &lt;select data-bind="options: Countries,optionsText: 'countryName', value: selectedCountry, optionsCaption: 'Choose...'"&gt;<br />
    &lt;/select&gt;<br />
&lt;/p&gt;<br />
&lt;div data-bind="visible: selectedCountry"&gt;<br />
       You have chosen a country with population<br />
    &lt;span data-bind="text: selectedCountry() ? selectedCountry().countryPopulation : 'unknown'"&gt;&lt;/span&gt;.<br />
&lt;/div&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var Country = function (name, population) {<br />
        this.countryName = name;<br />
        this.countryPopulation = population;<br />
    };<br />
    var viewModel = {<br />
        availableCountries: ko.observableArray(['France', 'Germany', 'Spain']),<br />
        selectedCountry: ko.observable(),<br />
        Countries: ko.observableArray([<br />
            new Country("UK", 65000000),<br />
            new Country("USA", 320000000),<br />
            new Country("Sweden", 29000000)<br />
        ])<br />
    };<br />
    ko.applyBindings(viewModel);<br />
    viewModel.availableCountries.push('China');<br />
&lt;/script&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/18102138-570e161888434baa9a5d815a2cf1f86b.png" /></p>
<p><strong>optionsCaption</strong></p>
<p>有时候，默认情况下不想选择任何option项。但是single-select drop-down列表由于每次都要默认选择以项目，怎么避免这个问题呢？常用的方案是加一个&ldquo;请选择的&rdquo;或者&ldquo;Select an item&rdquo;的提示语，或者其它类似的，然后让这个项作为默认选项。</p>
<p>我们使用optionsCaption参数就能很容易实现，它的值是字符串型，作为默认项显示。例如：</p>
<p>&lt;select data-bind='options: myOptions, optionsCaption: "Select an item...", value: myChosenValue'&gt;&lt;/select&gt;</p>
<p>KO会在所有选项上加上这一个项，并且设置value值为undefined。所以，如果myChosenValue被设置为undefined（默认是observable的），那么上述的第一个项就会被选中</p>
<p>Drop-down list展示的任意JavaScript对象，显示text是function的返回值</p>
<div>
<pre class="prettyprint linenums">&lt;select data-bind="options: Countries,<br />
                   optionsText: function(item) { return item.countryName + ' (pop: ' + item.countryPopulation + ')' },<br />
                   value: selectedCountry,<br />
                   optionsCaption: 'Choose...'"&gt;<br />
&lt;/select&gt;</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/401119/201310/18110412-59ebb182edfb4770a907d5334edbf541.png" /></p>
<p><strong>optionsText</strong></p>
<p>上面《Drop-down list展示的任意JavaScript对象，不仅仅是字符串》中展示的绑定 JavaScript对象到option上 &ndash; 不仅仅是字符串。这时候你需要设置这个对象的那个属性作为drop-down列表或multi-select列表的text来显示。设置额外的参数 optionsText将对象的属性名countryName作为显示的文本。</p>
<p>如果不想仅仅显示对象的属性值作为每个item项的text值，那你可以设置optionsText 为JavaScript 函数，然后再函数里通过自己的逻辑返回相应的值（该函数参数为item项本身）。</p>
<p><strong>optionsValue</strong></p>
<p>和optionsText类似, 你也可以通过额外参数optionsValue来声明对象的那个属性值作为该&lt;option&gt;的value值。</p>
<p>经典场景：如在更新options的时候想保留原来的已经选择的项。例如，当你重复多次调用Ajax获取car列表的时候，你要确保已经选择的某个 car一直都是被选择上，那你就需要设置optionsValue为&ldquo;carId&rdquo;或者其它的unique标示符，否则的话KO找不知道之前选择的car 是新options里的哪一项</p>
<p><strong>selectedOptions</strong></p>
<p>对于multi-select列表，你可以用selectedOptions读取和设置多个选择项。技术上看它是一个单独的绑定，有自己的文档，请参考： selectedOptions绑定。</p>
<p><a href="http://www.cnblogs.com/aehyok/p/3375966.html" rel="external nofollow noreferrer">Knockout.Js官网学习（selectedOptions绑定、uniqueName 绑定）</a></p>
<div>
<p>selectedOptions绑定</p>
<p>selectedOptions绑定用于控制multi-select列表已经被选择的元素，用在使用options绑定的&lt;select&gt;元素上。</p>
<p>当用户在multi-select列表选择或反选一个项的时候，会将view model的数组进行相应的添加或者删除。同样，如果view model上的这个数组是observable数组的话，你添加或者删除任何item（通过push或者splice）的时候，相应的UI界面里的 option项也会被选择上或者反选。这种方式是2-way绑定。</p>
<p>注：控制single-select下拉菜单选择项，你可以使用value绑定。</p>
<p>示例代码</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;p&gt;    Choose some countries you'd like to visit:<br />
    &lt;select data-bind="options: availableCountries, selectedOptions: chosenCountries" size="5" multiple="true"&gt;<br />
    &lt;/select&gt;<br />
&lt;/p&gt;<br />
&lt;script type="text/javascript" src="~/Scripts/knockout-2.3.0.debug.js"&gt;&lt;/script&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var viewModel = {<br />
        availableCountries: ko.observableArray(['France', 'Germany', 'Spain']),<br />
        chosenCountries: ko.observableArray(['Germany'])<br />
    };<br />
    ko.applyBindings(viewModel);<br />
    viewModel.chosenCountries.push('France');<br />
&lt;/script&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>该参数是数组（或observable数组）。KO设置元素的已选项为和数组里match的项，之前的已选择项将被覆盖。</p>
<p>如果参数是依赖监控属性observable数组，那元素的已选择项selected options项将根据参数值的变化（通过push，pop，或其它observable数组方法）而更新，如果不是，那元素的已选择项selected options将只设置一次并且以后不在更新。</p>
<p>不管该参数是不是observable数组，用户在multi-select列表里选择或者反选的时候，KO都会探测到，并且更新数组里的对象以达到同步的结果。这样你就可以获取options已选项。</p>
<p><strong>支持让用户选择任意JavaScript对象 </strong></p>
<p>在上面的例子里，用户可以选择数组里的字符串值，但是选择不限于字符串，如果你愿意你可以声明包含任意JavaScript对象的数组，查看<a href="http://www.cnblogs.com/TomXu/archive/2011/11/24/2256904.html#_options_%E7%BB%91%E5%AE%9A" rel="external nofollow noreferrer">options绑定</a>如何显示JavaScript对象到列表里。</p>
<p>这种场景，你可以用selectedOptions来读取或设置这些对象本身，而不是页面上显示的option表示形式，这样做在大部分情况下都非 常清晰。view model就可以探测到你从数组对象里选择的项了，而不必关注每个项和页面上展示的option项是如何map的。</p>
<p>uniqueName绑定</p>
<p>uniqueName绑定确保所绑定的元素有一个非空的name属性。如果该元素没有name属性，那绑定会给它设置一个unique的字符串值作为name属性。你不会经常用到它，只有在某些特殊的场景下才用到。</p>
<p>　　1.在使用KO的时候，一些技术可能依赖于某些元素的name属性，尽快他们没有什么意义。例如，jQuery Validation验证当前只验证有name属性的元素。为配合Knockout UI使用，有些时候需要使用uniqueName绑定避免让jQuery Validation验证出错。</p>
<p>　　2.IE 6下，如果radio button没有name属性是不允许被checked了。大部分时候都没问题，因为大部分时候radio button元素都会有name属性的作为一组互相的group。不过，如果你没声明，KO内部会在这些元素上使用uniqueName那么以确保他们可 以被checked。</p>
<p>例如：</p>
<div>
<pre class="prettyprint linenums">&lt;input data-bind="value: someModelProperty, uniqueName: true"/&gt;</pre>
</div>
<p>就像上面的例子一样，传入true（或者可以转成true的值）以启用uniqueName绑定。</p>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdw0kj9.html">mysql如何在一个字段后面加个字符？</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2kmkwq.html">iOS--UIAlertView与UIAlertController和UIAlertAction之间的事儿</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jrp08.html">移动硬盘安装win7，蓝屏，0x0000007B</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwy32y8.html">Auty自动化测试框架第三篇&mdash;&mdash;添加异常处理与日志收集</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qykjmd9.html">POJ 2083 Fractal</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdyl178.html">文件拷贝以及base64</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5oexq.html">iOS自定义的UISwitch按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpe7w0q.html">调用WCF的异步方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k3xp09.html">&lbrack;BJOI2019&rsqb;奥术神杖</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwn3e48.html">PyQt5&mdash;&mdash;高级控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1zr6q.html">WebClient&comma; HttpClient&comma; HttpWebRequest &comma;RestSharp之间的区别与抉择</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jmwz5q.html">Newtonsoft&period;Json添加项</a>
		</li>
						<li><a href="https://www.batexi.com/a/90re47m9.html">五&period;Bash Shell编程基础入门实战</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjwx1z9.html">python  import  其他 package的模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1ep0e9.html">WPF编程，通过【帧】动态更改控件属性的一种方法。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emm3xx9.html">使用JAAS登录kerberos服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn22vxq.html">&num; 20155327 2016-2017-3 《Java程序设计》第5周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvxwyjq.html">整理一下关于Crypto加密的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2rzjd8.html">获取网站资源  getResourceAsStream</a>
		</li>
						<li><a href="https://www.batexi.com/a/902xxe4q.html">QByteArray to QString</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93xpxyg9.html">Andriod项目开发实战（2）&mdash;&mdash;JSON和XML的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn2nme8.html">多文件目录下makefile文件递归执行编译所有c文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdljdl8.html">【spring 4】AOP：动态代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1koed9.html">自适应中overflow的作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xpy0w9.html">WinDbg调试CPU占用高的问题 试验&plus;实战 《第七篇》</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn22wz8.html">纯servlet返回xml数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnjjloq.html">（笔记）angular material 选项卡用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wkxplq.html">LLVM language 参考手册（译）（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v2jvj8.html">设计模式-工厂方法模式&lpar;FactoryMethod&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn25nz8.html">Oracle数据库中的Function调用参数问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
